<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for BasicFileComparator.
 * Generated by PHPUnit on 2012-07-03 at 17:39:01.
 * @group directory_iterators
 */
class BasicFileComparatorTest extends \PHPUnit_Framework_TestCase {

    /** @var BasicFileComparator */
    private $comparator;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $biggerElement;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $smallererElement;

    protected function setUp() {
        $this->comparator = new BasicFileComparator();
        $this->biggerElement = $this->getElement('existing-žeš');
        $this->smallererElement = $this->getElement('test');
    }

    public function testCompareBySize() {        
        $this->comparator->setComparableAttribute(BasicFileComparator::SIZE);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->biggerElement), 0);
        parent::assertEquals($this->comparator->compare($this->smallererElement, $this->smallererElement), 0);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->smallererElement), 1);
        parent::assertEquals($this->comparator->compare($this->smallererElement, $this->biggerElement), -1);
    }

    public function testCompareByModificationDate() {
        $this->comparator->setComparableAttribute(BasicFileComparator::MODIFICATION_DATE);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->biggerElement), 0);
        parent::assertEquals($this->comparator->compare($this->smallererElement, $this->smallererElement), 0);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->smallererElement), $this->getCompareResult('filemtime'));
    }

    public function testCompareByCreationDate() {
        $this->comparator->setComparableAttribute(BasicFileComparator::CREATION_DATE);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->biggerElement), 0);
        parent::assertEquals($this->comparator->compare($this->smallererElement, $this->smallererElement), 0);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->smallererElement), $this->getCompareResult('filectime'));
    }

    public function testCompareByLastAccessDate() {
        $this->comparator->setComparableAttribute(BasicFileComparator::ACCESS_DATE);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->biggerElement), 0);
        parent::assertEquals($this->comparator->compare($this->smallererElement, $this->smallererElement), 0);
        parent::assertEquals($this->comparator->compare($this->biggerElement, $this->smallererElement), $this->getCompareResult('fileatime'));
    }

    private function getCompareResult($function) {        
        $a = call_user_func($function, $this->biggerElement->splFileInfo->getPathname());
        $b = call_user_func($function, $this->smallererElement->splFileInfo->getPathname());
        return \Treewec\Utils\Comparators::compareNumbers($a, $b);
    }

    /** return Treewec\DirectoryIterators\IteratorElement */
    private function getElement($name) {
        $name = \Treewec\FileSystem\Path::toFileSystem($name);
        return new IteratorElement(0, new \SplFileInfo(TEMP_FILEDIR . $name . '.php'));
    }

}

?>